#pragma once

class CImeDocState {
} ;

class CStateMessageLoop : public CImeDocState {
public:
	static	int		LM_iMessageLoop	(CImeDoc* pThis) ;

private:
	/* JړȑԁBJڂ̐擪ƂČĂ΂邱Ƃ͂ȂB*/
	static	int		LM_iMessageLoop_1			(CImeDoc* pThis) ;
	static	int		LM_iPostMessageLoop			(CImeDoc* pThis) ;
	static	int		LM_iPostMessageLoop_1		(CImeDoc* pThis) ;
	static	int		LM_iPostMessageLoop_2		(CImeDoc* pThis) ;
} ;

class CStateSelfInsertCharacter : public CImeDocState {
public:
	static	int		LM_bSelfInsertCharacter		(CImeDoc* pThis) ;
} ;

class CStateBackwardChar : public CImeDocState {
public:
	static	int		LM_bBackwardChar			(CImeDoc* pThis) ;
} ;

class CStateForwardChar : public CImeDocState {
public:
	static	int		LM_bForwardChar				(CImeDoc* pThis) ;
} ;

class CStateDeleteChar : public CImeDocState {
public:
	static	int		LM_bDeleteChar				(CImeDoc* pThis) ;
} ;

class CStateBackwardDeleteChar : public CImeDocState {
public:
	static	int		LM_bBackwardDeleteChar		(CImeDoc* pThis) ;
} ;

class CStateTransposeChars : public CImeDocState {
public:
	static	int		LM_bTransposeChars			(CImeDoc* pThis) ;
} ;

class CStateEndOfLine : public CImeDocState {
public:
	static	int		LM_bEndOfLine				(CImeDoc* pThis) ;
} ;

class CStateBeginningOfLine : public CImeDocState {
public:
	static	int		LM_bBeginningOfLine			(CImeDoc* pThis) ;
} ;

class CStateSetMarkCommand : public CImeDocState {
public:
	static	int		LM_bSetMarkCommand			(CImeDoc* pThis) ;
} ;

class CStateKeyboardQuit : public CImeDocState {
public:
	static	int		LM_bKeyboardQuit			(CImeDoc* pThis) ;
private:
	static	int		LM_bKeyboardQuit_1			(CImeDoc* pThis) ;
} ;

class CStateNextCommandEvent : public CImeDocState {
public:
	static	int		LM_bNextCommandEvent		(CImeDoc* pThis) ;
} ;

class CStateReadFromMinibuffer : public CImeDocState {
public:
	static	int		LM_bReadFromMinibuffer		(CImeDoc* pThis) ;
private:
	static	int		LM_bReadFromMinibuffer_Exit	(CImeDoc* pThis) ;
} ;

class CStateYesOrNop : public CImeDocState {
public:
	static	int		LM_bYesOrNop				(CImeDoc* pThis) ;
private:
	static	int		LM_bYesOrNop_1				(CImeDoc* pThis) ;
	static	int		LM_bYesOrNop_2				(CImeDoc* pThis) ;
	static	int		LM_bYesOrNop_Exit			(CImeDoc* pThis) ;
} ;

class CStateAbortRecursiveEdit : public CImeDocState {
public:
	static	int		LM_bAbortRecursiveEdit		(CImeDoc* pThis) ;
private:
	static	int		LM_bAbortRecursiveEdit_1	(CImeDoc* pThis) ;
} ;

class CStateExitRecursiveEdit : public CImeDocState {
public:
	static	int		LM_bExitRecursiveEdit		(CImeDoc* pThis) ;
private:
	static	int		LM_bExitRecursiveEdit_1 	(CImeDoc* pThis) ;
} ;

class CStateNewline : public CImeDocState {
public:
	static	int		LM_bNewline					(CImeDoc* pThis) ;
private:
	static	int		LM_bNewline_1				(CImeDoc* pThis) ;
} ;

class CStateNextLine : public CImeDocState {
public:
	static	int		LM_bNextLine				(CImeDoc* pThis) ;
} ;

class CStatePreviousLine : public CImeDocState {
public:
	static	int		LM_bPreviousLine			(CImeDoc* pThis) ;
} ;

class CStateUnprocessEvent : public CImeDocState {
public:
	static	int		LM_bUnprecessEvent			(CImeDoc* pThis) ;
} ;

/*	skk-side
 */
class CStateSkkPreCommand : public CImeDocState {
public:
	static int		LM_bSkkPreCommand			(CImeDoc* pThis) ;
} ;

class CStateSkkPostCommand : public CImeDocState {
public:
	static int		LM_bSkkPostCommand			(CImeDoc* pThis) ;
} ;

class CStateSkkMode : public CImeDocState {
public:
	static int		LM_bSkkMode					(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkMode_1	(CImeDoc* pThis) ;
	static	int		LM_bSkkModeExit_1	(CImeDoc* pThis) ;
	static	int		LM_bSkkModeExit (CImeDoc* pThis) ;
} ;

class CStateSkkLatinMode : public CImeDocState {
public:
	static int		LM_bSkkLatinMode			(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkLatinMode_1 (CImeDoc* pThis) ;
} ;

class CStateSkkJisx0208LatinMode : public CImeDocState {
public:
	static int		LM_bSkkJisx0208LatinMode	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkJisx0208LatinMode_1 (CImeDoc* pThis) ;
} ;

class CStateSkkAbbrevMode : public CImeDocState {
public:
	static int		LM_bSkkAbbrevMode			(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkAbbrevMode_1 (CImeDoc* pThis) ;
	static	int		LM_bSkkAbbrevMode_2 (CImeDoc* pThis) ;
} ;

class CStateSkkInsert : public CImeDocState {
public:
	static int		LM_bSkkInsert				(CImeDoc* pThis) ;
private:
	static int		LM_bSkkInsert_Exit			(CImeDoc* pThis) ; /* */
} ;

class CStateSkkEmulateOriginalMap : public CImeDocState {
public:
	static int		LM_bSkkEmulateOriginalMap	(CImeDoc* pThis) ;
} ;

class CStateSkkSetHenkanPoint : public CImeDocState {
public:
	static int		LM_bSkkSetHenkanPoint		(CImeDoc* pThis) ;
} ;

class CStateSkkProcessPrefixOrSuffix : public CImeDocState {
public:
	static	int		LM_bSkkProcessPrefixOrSuffix	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkProcessPrefixOrSuffix_1	(CImeDoc* pThis) ;
	static	int		LM_bSkkProcessPrefixOrSuffix_2	(CImeDoc* pThis) ;
	static	int		LM_bSkkProcessPrefixOrSuffix_3	(CImeDoc* pThis) ;
} ;

class CStateSkkKanaInput : public CImeDocState {
public:
	static int		LM_bSkkKanaInput			(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkKanaInput_1			(CImeDoc* pThis) ;
	static	int		LM_bSkkKanaInput_1_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkKanaInput_3			(CImeDoc* pThis) ;
	static	int		LM_bSkkKanaInput_3_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkKanaInput_3_2		(CImeDoc* pThis) ;
	static	int		LM_bSkkKanaInput_4			(CImeDoc* pThis) ;
	static	int		LM_bSkkKanaInput_4_0		(CImeDoc* pThis) ;
	static	int		LM_bSkkKanaInput_4_0_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkKanaInput_4_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkKanaInput_Exit		(CImeDoc* pThis) ;
} ;

class CStateSkkHenkan : public CImeDocState {
public:
	static int		LM_bSkkHenkan				(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkHenkan_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkan_3		(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkan_4		(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkan_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkHenkan1 : public CImeDocState {
public:
	static	int		LM_bSkkHenkan1 (CImeDoc* pThis) ;
} ;

class CStateSkkSetHenkanPointSubr : public CImeDocState {
	static int		LM_bSkkSetHenkanPointSubr	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkSetHenkanPointSubr_1 (CImeDoc* pThis) ;
	static	int		LM_bSkkSetHenkanPoint_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkSetHenkanPoint_2		(CImeDoc* pThis) ;
	static	int		LM_bSkkSetHenkanPoint_3		(CImeDoc* pThis) ;
	static	int		LM_bSkkSetHenkanPoint_4		(CImeDoc* pThis) ;
	static	int		LM_bSkkSetHenkanPoint_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkKakutei : public CImeDocState {
public:
	static int		LM_bSkkKakutei				(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkKakutei_1 (CImeDoc* pThis) ;
	static	int		LM_bSkkKakutei_2 (CImeDoc* pThis) ;
	static	int		LM_bSkkKakutei_3 (CImeDoc* pThis) ;
	static	int		LM_bSkkKakutei_4 (CImeDoc* pThis) ;
	static	int		LM_bSkkKakutei_5 (CImeDoc* pThis) ;
} ;

class CStateSkkStartHenkan : public CImeDocState {
public:
	static int		LM_bSkkStartHenkan			(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkStartHenkan_1	(CImeDoc* pThis) ;
	static	int		LM_bSkkStartHenkan_2	(CImeDoc* pThis) ;
} ;

class CStateSkkSetOkurigana : public CImeDocState {
public:
	static int		LM_bSkkSetOkurigana			(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkSetOkurigana_1 (CImeDoc* pThis) ;
} ;

class CStateSkkPreviousCandidate : public CImeDocState {
public:
	static int		LM_bSkkPreviousCandidate	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkPreviousCandidate_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkPreviousCandidate_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkDeleteBackwardChar : public CImeDocState {
public:
	static int		LM_bSkkDeleteBackwardChar	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkDeleteBackwardChar_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkDeleteBackwardChar_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkTryCompletion : public CImeDocState {
public:
	static int		LM_bSkkTryCompletion		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkTryCompletion_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkTryCompletion_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkAbbrevComma : public CImeDocState {
public:
	static int		LM_bSkkAbbrevComma			(CImeDoc* pThis) ;
} ;

class CStateSkkAbbrevPeriod : public CImeDocState {
public:
	static int		LM_bSkkAbbrevPeriod			(CImeDoc* pThis) ;
} ;

class CStateSkkToggleCharacters : public CImeDocState {
public:
	static int		LM_bSkkToggleCharacters		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkToggleCharacters_1 (CImeDoc* pThis) ;
	static	int		LM_bSkkToggleCharacters_2 (CImeDoc* pThis) ;
} ;

class CStateSkkHiraganaRegion : public CImeDocState {
public:
	static int		LM_bSkkHiraganaRegion		(CImeDoc* pThis) ;
} ;

class CStateSkkKatakanaRegion : public CImeDocState {
public:
	static int		LM_bSkkKatakanaRegion		(CImeDoc* pThis) ;
} ;

class CStateSkkJisx0208LatinRegion : public CImeDocState {
public:
	static int		LM_bSkkJisx0208LatinRegion	(CImeDoc* pThis) ;
} ;

class CStateSkkLatinRegion : public CImeDocState {
public:
	static int		LM_bSkkLatinRegion			(CImeDoc* pThis) ;
} ;

class CStateSkkJisx0208LatinInsert : public CImeDocState {
public:
	static int		LM_bSkkJisx0208LatinInsert	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkJisx0208LatinInsert_1	(CImeDoc* pThis) ;
	static	int		LM_bSkkJisx0208LatinInsert_2	(CImeDoc* pThis) ;
	static	int		LM_bSkkJisx0208LatinInsert_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkHenkanInMinibuff : public CImeDocState {
public:
	static	int		LM_bSkkHenkanInMinibuff		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkHenkanInMinibuff_1 (CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanInMinibuff_S2 (CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanInMinibuff_S3 (CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanInMinibuff_S4 (CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanInMinibuff_Exit (CImeDoc* pThis) ;
} ;

class CStateSkkAdKeyboardQuit : public CImeDocState {
public:
	static int		LM_bSkkAdKeyboardQuit		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkKeyboardQuit_1 (CImeDoc* pThis) ;
} ;

class CStateSkkAdAbortRecursiveEdit : public CImeDocState {
public:
	static int		LM_bSkkAdAbortRecursiveEdit	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkAbortRecursiveEdit_1		(CImeDoc* pThis) ;
} ;

class CStateSkkAdExitMinibuffer : public CImeDocState {
public:
	static int		LM_bSkkAdExitMinibuffer		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkExitMinibuffer_1		(CImeDoc* pThis) ;
} ;

class CStateSkkAdNextLine : public CImeDocState {
public:
	static int		LM_bSkkAdNextLine			(CImeDoc* pThis) ;
} ;

class CStateSkkAdPreviousLine : public CImeDocState {
public:
	static int		LM_bSkkAdPreviousLine		(CImeDoc* pThis) ;
} ;

class CStateSkkAdNewline : public CImeDocState {
public:
	static int		LM_bSkkAdNewline			(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkAdNewline_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkAdNewline_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkAutoStartHenkan : public CImeDocState {
public:
	static int		LM_bSkkAutoStartHenkan		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkAutoStartHenkan_1	(CImeDoc* pThis) ;
	static	int		LM_bSkkAutoStartHenkan_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkInsertStr : public CImeDocState {
public:
	static int		LM_bSkkInsertStr			(CImeDoc* pThis) ;
} ;

class CStateSkkKanaCleanup : public CImeDocState {
public:
	static int		LM_bSkkKanaCleanup			(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkKanaCleanup_1 (CImeDoc* pThis) ;
	static	int		LM_bSkkKanaCleanup_2 (CImeDoc* pThis) ;
} ;

class CStateSkkToggleKutouten : public CImeDocState {
public:
	static int		LM_bSkkToggleKutouten		(CImeDoc* pThis) ;
} ;

class CStateSkkCurrentKuten : public CImeDocState {
public:
	static int		LM_bSkkCurrentKuten			(CImeDoc* pThis) ;
} ;

class CStateSkkCurrentTouten : public CImeDocState {
public:
	static int		LM_bSkkCurrentTouten		(CImeDoc* pThis) ;
} ;

class CStateSkkPurgeFromJisyo : public CImeDocState {
public:
	static int		LM_bSkkPurgeFromJisyo		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkPurgeFromJisyo_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkPurgeFromJisyo_2		(CImeDoc* pThis) ;
	static	int		LM_bSkkPurgeFromJisyo_3		(CImeDoc* pThis) ;
	static	int		LM_bSkkPurgeFromJisyo_4		(CImeDoc* pThis) ;
	static	int		LM_bSkkPurgeFromJisyo_5		(CImeDoc* pThis) ;
	static	int		LM_bSkkPurgeFromJisyo_Exit	(CImeDoc* pThis) ;
} ;

/*	skk-comp-side
 */
class CStateSkkComp : public CImeDocState {
public:
	static int		LM_bSkkComp					(CImeDoc* pThis) ;
} ;

class CStateSkkCompDo : public CImeDocState {
public:
	static int		LM_bSkkCompDo				(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkCompDo_1 (CImeDoc* pThis) ;
} ;

class CStateSkkCompPrevious : public CImeDocState {
public:
	static int		LM_bSkkCompPrevious			(CImeDoc* pThis) ;
} ;

class CStateSkkCompPreviousNext : public CImeDocState {
public:
	static int		LM_bSkkCompPreviousNext		(CImeDoc* pThis) ;
} ;

/*	skk-kcode-side
 */
class CStateSkkInputByCodeOrMenu : public CImeDocState {
public:
	static int		LM_bSkkInputByCodeOrMenu	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkInputByCodeOrMenu_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkInputByCodeOrMenu_2		(CImeDoc* pThis) ;
	static	int		LM_bSkkInputByCodeOrMenu_3		(CImeDoc* pThis) ;
	static	int		LM_bSkkInputByCodeOrMenu_Exit	(CImeDoc* pThis) ;
} ;

/*	ǉ: 
 */
class CStateSkkSetCharBeforeAsOkurigana : public CImeDocState {
public:
	static int		LM_bSkkSetCharBeforeAsOkurigana	(CImeDoc* pThis) ;
} ;

/*	private?
 */
class CStateSkkHenkanSkkRegionByFunc : public CImeDocState {
public:
	static	int		LM_bSkkHenkanSkkRegionByFunc	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkHenkanSkkRegionByFunc_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanSkkRegionByFunc_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkChangeMarker : public CImeDocState {
public:
	static	int		LM_bSkkChangeMarker	 (CImeDoc* pThis) ;
private:
	static	int		LM_bSkkChangeMarker_1 (CImeDoc* pThis) ;
} ;

class CStateSkkUpdateJisyo : public CImeDocState {
public:
	static	int		LM_bSkkUpdateJisyo		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkUpdateJisyo_1	(CImeDoc* pThis) ;
	static	int		LM_bSkkUpdateJisyo_2	(CImeDoc* pThis) ;
	static	int		LM_bSkkUpdateJisyo_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkRemoveCommon : public CImeDocState {
public:
	static	int		LM_bSkkRemoveCommon				(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkRemoveCommon_1			(CImeDoc* pThis) ;
} ;

class CStateSkkHenkanShowCandidates : public CImeDocState {
public:
	static	int		LM_bSkkHenkanShowCandidates		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkHenkanShowCandidates_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanShowCandidates_2		(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanShowCandidates_3		(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanShowCandidates_4		(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanShowCandidates_5		(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanShowCandidates_Exit_0	(CImeDoc* pThis) ;
	static	int		LM_bSkkHenkanShowCandidates_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkInputByCodeOrMenu0 : public CImeDocState {
public:
	static	int		LM_bSkkInputByCodeOrMenu0		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkInputByCodeOrMenu0_1		(CImeDoc* pThis) ;
} ;

class CStateSkkInputByCodeOrMenuJump : public CImeDocState {
public:
	static	int		LM_bSkkInputByCodeOrMenuJump	(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkInputByCodeOrMenuJump_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkInputByCodeOrMenuJump_2		(CImeDoc* pThis) ;
	static	int		LM_bSkkInputByCodeOrMenuJump_Exit	(CImeDoc* pThis) ;
} ;

class CStateSkkInputByCodeOrMenu1 : public CImeDocState {
public:
	static	int		LM_bSkkInputByCodeOrMenu1		(CImeDoc* pThis) ;
private:
	static	int		LM_bSkkInputByCodeOrMenu1_1		(CImeDoc* pThis) ;
	static	int		LM_bSkkInputByCodeOrMenu1_2		(CImeDoc* pThis) ;
	static	int		LM_bSkkInputByCodeOrMenu1_Exit	(CImeDoc* pThis) ;
} ;



