/*	cleanup.cpp
 *
 *	ITfCleanupContextSink implementation
 */
#include "globals.h"
#include "skimic.h"
#include "skkimmgr.h"

STDAPI
CSkkImeTextService::OnStartCleanupContext ()
{
	_fCleaningUp	= TRUE ;
	return	S_OK ;
}

STDAPI
CSkkImeTextService::OnEndCleanupContext ()
{
	_fCleaningUp	= FALSE ;
	return	S_OK ;
}

/*	ITfCleanupContextSink::OnCleanupContext
 *
 *	X deactivate 悤ƂĂ̂ȂAVXe͂ method
 *	 call B context  text CłŌ̃`Xł
 *	BꂪAongoing composition  abort 鎞łH
 *
 *	 app SĂ context  TSF  deactive Oɔĵ
 *	A callback  app  shutdown Ă̂ƌ邽߂Ɏg
 *	Ƃ͂łȂB
 */
STDAPI
CSkkImeTextService::OnCleanupContext (
	TfEditCookie	ecWrite,
	ITfContext*		pContext)
{
	DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnCleanupContext ()\n"))) ;
	return	S_OK ;
}

/*	_InitCleanupContextSink
 *
 *	̑삪ӖĂ̂cǂȂBvAB
 */
BOOL
CSkkImeTextService::_InitCleanupContextSink (
	ITfContext*		pContext)
{
	return	AdviseSingleSink (
		_tfClientId,
		pContext,
		(ITfCleanupContextSink *)this,
		IID_ITfCleanupContextSink) ;
}

/*	_UninitCleanupContextSink
 */
void
CSkkImeTextService::_UninitCleanupContextSink (
	ITfContext*		pContext)
{
	UnadviseSingleSink (_tfClientId, pContext, IID_ITfCleanupContextSink) ;
	return ;
}








